import 'dart:core';
import 'package:dogs_core/dogs_core.dart' as gen;
import 'package:lyell/lyell.dart' as gen;
import 'dart:core' as gen0;
import 'package:dogs_forms/src/field.dart' as gen1;
import 'package:flutter/src/rendering/box.dart' as gen2;
import 'package:dogs_core/validation/length.dart' as gen3;
import 'package:example/models/address.dart' as gen4;
import 'package:dogs_forms/src/form.dart' as gen5;
import 'package:example/models/address.dart';

class AddressConverter extends gen.DefaultStructureConverter<gen4.Address> {
  AddressConverter()
      : super(
            struct: const gen.DogStructure<gen4.Address>(
                'Address',
                gen.StructureConformity.dataclass,
                [
                  gen.DogStructureField(gen.QualifiedTerminal<gen0.String>(), gen.TypeToken<gen0.String>(), null, gen.IterableKind.none, 'street', false, false, [gen1.AutoFormField(flex: 6)]),
                  gen.DogStructureField(gen.QualifiedTerminal<gen0.String>(), gen.TypeToken<gen0.String>(), null, gen.IterableKind.none, 'city', false, false, [gen1.AutoFormField(flex: 3)]),
                  gen.DogStructureField(gen.QualifiedTerminal<gen0.String>(), gen.TypeToken<gen0.String>(), null, gen.IterableKind.none, 'zip', false, false,
                      [gen1.AutoFormField(constraints: gen2.BoxConstraints(maxWidth: 96.0), flex: -1), gen3.LengthRange(min: 5, max: 5)])
                ],
                [gen5.AutoForm(decorator: gen4.AddressDecorator())],
                gen.ObjectFactoryStructureProxy<gen4.Address>(_activator, [_$street, _$city, _$zip], _values, _hash, _equals)));

  static dynamic _$street(gen4.Address obj) => obj.street;

  static dynamic _$city(gen4.Address obj) => obj.city;

  static dynamic _$zip(gen4.Address obj) => obj.zip;

  static List<dynamic> _values(gen4.Address obj) => [obj.street, obj.city, obj.zip];

  static gen4.Address _activator(List list) {
    return Address(list[0], list[1], list[2]);
  }

  static int _hash(gen4.Address obj) => obj.street.hashCode ^ obj.city.hashCode ^ obj.zip.hashCode;

  static bool _equals(
    gen4.Address a,
    gen4.Address b,
  ) =>
      (a.street == b.street && a.city == b.city && a.zip == b.zip);
}

class AddressBuilder {
  AddressBuilder([gen4.Address? $src]) {
    if ($src == null) {
      $values = List.filled(3, null);
    } else {
      $values = AddressConverter._values($src);
    }
  }

  late List<dynamic> $values;

  set street(gen0.String value) {
    $values[0] = value;
  }

  gen0.String get street => $values[0];

  set city(gen0.String value) {
    $values[1] = value;
  }

  gen0.String get city => $values[1];

  set zip(gen0.String value) {
    $values[2] = value;
  }

  gen0.String get zip => $values[2];

  gen4.Address build() => AddressConverter._activator($values);
}

extension AddressDogsExtension on gen4.Address {
  @Deprecated("Use rebuild() instead")
  gen4.Address builder(Function(AddressBuilder builder) func) {
    var builder = AddressBuilder(this);
    func(builder);
    return builder.build();
  }

  gen4.Address rebuild(Function(AddressBuilder b) f) {
    var builder = AddressBuilder(this);
    f(builder);
    return builder.build();
  }

  AddressBuilder toBuilder() {
    return AddressBuilder(this);
  }

  Map<String, dynamic> toNative() {
    return gen.dogs.convertObjectToNative(this, gen4.Address);
  }
}
